var APIBase = require("../../api.base");
var system = require("../../../system");
var settings = require("../../../../config/settings");
class OrderAPI extends APIBase {
    constructor() {
        super();
        this.orderinfoSve = system.getObject("service.dbcorder.orderinfoSve");
    }
    /**
      * 接口跳转-POST请求
      * action_process  执行的流程
      * action_type     执行的类型
      * action_body     执行的参数
      */
    async springBoard(pobj, qobj, req) {
        if (!pobj.userInfo) {
            return system.getResultFail(system.noLogin, "user no login!");
        }
        if (!pobj.actionType) {
            return system.getResult(null, "actionType参数不能为空");
        }
        var result = await this.opActionProcess(pobj, pobj.actionType, req);
        return result;
    }
    async opActionProcess(pobj, action_type, req) {
        var opResult = null;
        switch (action_type) {
            case "addOrder"://创建订单
                opResult = await this.addOrder(pobj, pobj.actionBody);
                await this.pushOrder(opResult, pobj, pobj.actionBody);
                break;
            case "getOrderList"://创建订单
                opResult = await this.orderinfoSve.getOrderList(pobj, pobj.actionBody);
                break;
            case "getPayOrderInfo"://获取付款订单信息
                opResult = await this.orderinfoSve.getPayOrderInfo(pobj, pobj.actionBody);
                break;
            case "putReceiptVoucherInfo"://修改订单收款信息
                opResult = await this.orderinfoSve.putReceiptVoucherInfo(pobj, pobj.actionBody);
                break;
            default:
                opResult = system.getResult(null, "action_type参数错误");
                break;
        }
        return opResult;
    }
    async addOrder(pobj, actionBody) {
        if (!actionBody.product_info) {
            return system.getResult(null, "产品信息有误，20010");
        }
        var interface_info = null;
        var interface_list = actionBody.product_info.interface_info;
        if (interface_list) {
            var interface_list_temp = interface_list.filter(f => f.op_type == "addOrder")
            if (interface_list_temp && interface_list_temp.length > 0) {
                interface_info = interface_list_temp[0];
            }
        }
        if (!interface_list) {
            interface_info = {
                interface_type: "bd",
                interface_url: "service.dbcorder.orderinfoSve",
                params: "createOtherOrder"
            };
        }//使用默认的其他订单

        if (!interface_info) {
            return system.getResult(null, "产品接口信息有误，20030");
        }
        if (!interface_info.interface_type) {
            return system.getResult(null, "产品接口类型信息有误，20050");
        }
        if (!interface_info.interface_url) {
            return system.getResult(null, "产品接口地址信息有误，20080");
        }
        var opResult = null;
        if (interface_info.interface_type == "bd") {
            if (!interface_info.params) {
                return system.getResult(null, "产品接口参数信息有误，20110");
            }//操作的方法名称
            var invokeObj = system.getObject(interface_info.interface_url);
            if (!invokeObj[interface_info.params]) {
                return system.getResult(null, "产品接口参数方法信息有误，20130");
            }
            var params = [pobj];
            opResult = await invokeObj[interface_info.params].apply(invokeObj, params);
        }
        else if (interface_info.interface_type == "yc") {

        }
        return opResult;
    }
    async pushOrder(opResult, pobj, actionBody) {
        if (opResult.status != 0) {
            return "";
        }
        var interface_info = null;
        var interface_list = actionBody.product_info.interface_info;
        if (interface_list) {
            var interface_list_temp = interface_list.filter(f => f.op_type == "pushOrder")
            if (interface_list_temp && interface_list_temp.length > 0) {
                interface_info = interface_list_temp[0];
            }
        }
        if (!interface_info) {
            return "";
        }
        //TODO:推送订单
    }

}
module.exports = OrderAPI;