const system = require("../../../system");
const Dao = require("../../dao.base");
class OrderInfoDao extends Dao {
  constructor() {
    super(Dao.getModelName(OrderInfoDao));
  }
  async getItemStatusByOrderNo(orderNo, uapp_id) {
    return await this.model.findOne({
      where: {
        orderNo: orderNo, uapp_id: uapp_id
      },
      attributes: [       
        "orderNo",
        "channelServiceNo",
        "channelOrderNo",
        "channelUserId",
        "ownerUserId",
        "payTime",
        "quantity",
        "serviceQuantity",
        "orderStatusName",
        "orderStatus",
        "totalSum",
        "payTotalSum",
        "refundSum",
        "invoiceApplyStatus"],
      raw: true
    });
  }
}
module.exports = OrderInfoDao;
